/*' $Header:   P:/PVCS/MAX/MAXIMIZE/WRCONFIG.C_V   1.1   26 Oct 1995 21:55:30   HENRY  $ */
/******************************************************************************
 *									      *
 * (C) Copyright 1991-92 Qualitas, Inc.  All rights reserved.		      *
 *									      *
 * WRCONFIG.C								      *
 *									      *
 *  Write CONFIG.SYS file						      *
 *									      *
 ******************************************************************************/

/* System Includes */
#include <stdio.h>
#include <string.h>

/* Local includes */
#include <commfunc.h>		/* Common functions */
#include <intmsg.h>		/* Intermediate message functions */
#include <mbparse.h>		/* MultiBoot defines */

#define WRCONFIG_C
#include <maxtext.h>		/* MAXIMIZE message text */
#include <maxvar.h>		/* MAXIMIZE global variables */
#undef WRCONFIG_C

#ifndef PROTO
#include "browse.pro"
#include "copyfile.pro"
#include "maximize.pro"
#include <maxsub.pro>
#include "screens.pro"
#include "wrconfig.pro"
#endif /*PROTO*/

/* Local variables */

/********************************** WRCONFIG **********************************/

void wrconfig (int pass)
{
	DSPTEXT *t;
	FILE *ot;
	char buff[256];
	char *textp;
	SECTNAME *menusect;
	int foundmenu = 0;

	/*---------------------------------------------------------*/
	/*	Before writing, save current file		       */
	/*---------------------------------------------------------*/

	if (pass == 1) {
		savefile (CONFIG);
		restbatappend (CONFIG);
	} /* End IF */

	if (AnyError)	/* If something went wrong, */
		return; 	/*  just return */

	do_intmsg(MsgUpdConf);

	if (MultiBoot) menusect = find_sect ("menu");

	/*---------------------------------------------------------*/
	/*	Disable CNTL BREAK and open the file		       */
	/*---------------------------------------------------------*/

	disable23 ();
	if ((ot = fopen (ActiveFiles[CONFIG], "w")) != NULL) {
		for (t = HbatStrt[CONFIG]; t && !AnyError; t = t->next)
			switch (pass) {
			case 1:
				if (t->max == 1)		/* If it's 386MAX */
				{
					strncpy (buff, t->text, t->nlead);
					sprintf (&buff[t->nlead], "%s pro=%s\n",
						t->devicen,
						t->profilen);
					AnyError = AnyError ? AnyError : fputs (buff, ot);

					break;
				} /* End IF */

				/* Otherwise, fall through */
				/* Note that we add 386LOAD GETSIZE to all */
				/* lines in CONFIG.SYS during Phase I. */
				/* In Phase II, we'll chuck out any that */
				/* didn't go resident or that allocated */
				/* UMBs.  We'll also defer relocation */
				/* of CONFIG.SYS lines in the Multiboot */
				/* environment until Phase II. */
			case 2:
				if (t->text != MsgRedundant) {
					fputs_text (br_buildcfg (t), ot); /* Output w/trailing LF */
				} // Ignore redundant lines

				break;

			case 3:
				/* If MultiBoot is active, we need to */
				/* remove the first two lines from the */
				/* first instance of the menu section and */
				/* remove any REM mX~ strings we find at */
				/* the beginning of a line. */
				textp = t->text;
				if (MultiBoot && menusect && pass == 3 &&
					t->MBOwner == menusect->OwnerID) {
				  if (t->MBtype == ID_SECT && !foundmenu) {
					foundmenu++;
					t = t->next;	/* Skip to MenuItem */
					if (t) t = t->next; /* Skip to MenuDefault */
				  } /* Start of first menu section */
				  else if (textp == strstr (textp, "REM mX~")) {
					textp += 7;	/* Skip to original */
				  } /* Found a magic cookie; eat it */
				} /* MultiBoot active and it's the menu */
				fputs_text (textp, ot); /* Output w/trailing LF */

				break;

			} /* End FOR/SWITCH */

		fclose (ot);

#ifdef STACKER
		SwapUpdate (CONFIG);
#endif			/* ifdef STACKER */
	} /* End IF */
	else
		AnyError = 1;

	if (AnyError) {
		/* Error writing CONFIG.SYS file */
		do_error(MsgErrConf,TRUE);
	}

	enable23 ();

} /* End WRCONFIG */

/******************************** FPUTS_TEXT **********************************/
/* Output text to a file ensuring it ends with a LF */

void fputs_text (char *text, FILE *ot)

{
	int len;

	AnyError = AnyError ? AnyError : fputs (text, ot);

	/* Avoid double LFs, but put one out if the line is empty */
	len = strlen (text);
	if (len == 0 || text[len - 1] != '\n')
		AnyError = AnyError ? AnyError : fputs ("\n", ot);

} /* End FPUTS_TEXT */
