/*' $Header:   P:/PVCS/MAX/MAXIMIZE/WRFILES3.C_V   1.2   26 Oct 1995 21:55:42   HENRY  $ */
/******************************************************************************
 *									      *
 * (C) Copyright 1991-93 Qualitas, Inc.  All rights reserved.		      *
 *									      *
 * WRFILES3.C								      *
 *									      *
 * MAXIMIZE write files, phase 3					      *
 *									      *
 ******************************************************************************/

/* System Includes */
#include <stdio.h>
#include <string.h>

/* Local includes */
#include <intmsg.h>		/* Intermediate message functions */
#include <max_sys.h>
#include <stacker.h>
#include <maxsub.pro>

#define WRFILES3_C		/* ..to select message text */
#include <maxtext.h>		/* MAX message text */
#include <maxvar.h>		/* MAXIMIZE global variables */
#undef WRFILES3_C

#ifndef PROTO
#include "copyfile.pro"
#include "maximize.pro"
#include "parse.pro"
#include "pass2.pro"
#include "proccfg1.pro"
#include "screens.pro"
#include "wrconfig.pro"
#include "wrfiles3.pro"
#endif /*PROTO*/

/* Local variables */

/* Local functions */

/********************************* WRFILES3 ************************************ */

void wrfiles3 (void)
{
	char buff[80];

	if (AnyError)
		return;

	wrconfig (Pass);	/* Write CONFIG.SYS file */
	wrprofile( FALSE, FALSE ); /* Write 386MAX.PRO file (no stripping) */
	wrbatfile (Pass);	/* Write .BAT files */

	/*--------------------------------------------------------------*/
	/*	Copy AUTOEXEC.ABETA to AUTOEXEC.BAT			*/
	/*--------------------------------------------------------------*/

	strcpy (buff, ActiveFiles[AUTOEXEC]);
	strcpy (strchr (buff, '.'), "." ABETA);
	copyfile (buff, ActiveFiles[AUTOEXEC]);

	/*-------------------------------------------------------------*/
	/*	Delete AUTOEXEC.ABETA					   */
	/*-------------------------------------------------------------*/

	do_intmsg (MsgDelAbeta);
	remove (buff);		/* Ignore error as there's not much we can do */
#ifdef STACKER
	if (SwappedDrive > 0 && CopyBoot) {
		buff[0] = CopyBoot;
		remove (buff);
	}
	SwapUpdate (AUTOEXEC);
#endif			/* ifdef STACKER */

#ifdef HARPO
	if (!maxcfg.noharpo) {
	if (harpo_pro() && Harpo_profile[0]) {
		do_intmsg (MsgHarpoPro);
		wrharpo ();
	} /* Harpo profile was created in Phase II */
	else	do_error (MsgNoHarpoPro, FALSE);
	} /* NOHARPO wasn't present in MAXIMIZE.CFG and it's not DR DOS */
#endif

} /* End WRFILES3 */

#ifdef HARPO
SUBSID *subsid (SUBFIT far *psubseg)
/* Return subsegment ID pointer from SubsIDs[] or SubsIDs[0] if none found */
{
 SUBSID *ret = SubsIDs; 	/* Default value */
 int i;

 for (i=1; SubsIDs[i].type; i++) {
	if (SubsIDs[i].owner == (BYTE) psubseg->ownr &&
		SubsIDs[i].type == psubseg->type)	ret = &(SubsIDs[i]);
 } /* End for () */

 return (ret);

} /* End subsid () */
#endif			/* ifdef HARPO */

#ifdef HARPO
void wrharpo (void)
/* Get HARPO profile, make changes to it, and save. */
{
 char fmt[80];
 SUBSID *psubsid;
 SUBFIT *psubseg;
 HARPOPROF *Hline;

 if (read_harpopro ()) {

	/* Clobber any existing HOPT_GETSIZE, HOPT_SUBSEG, and */
	/* HOPT_COMMAND lines (other than ones with NOLOADHI). */
	/* We just convert 'em to HOPT_DEADMAN, which is always */
	/* ignored on output. */
	for (Hline = HarpoPro; Hline; Hline = Hline->next)
	  switch (Hline->optype) {
	    case HOPT_SUBSEG:
	    case HOPT_CCOM:
		if (!_strnicmp (Hline->arg1, "NOLOADHI", 8)) break;
		/* Otherwise, fall through */
	    case HOPT_GETSIZE:
		Hline->optype = HOPT_DEADMAN;
		break;
	  } /* for / switch () */

	/* Write HARPO subsegment lines to profile */
	for (psubseg = psubsegs; psubseg && psubseg->lseg; psubseg++) {
		if (psubseg->ownr == SFO_HARPO) {
			psubsid = subsid (psubseg);
			// F=%ld,%d	; Move FILES to region %d for %ld bytes
			sprintf (fmt, "%s%s", psubsid->keywd, psubsid->comment);
			add2harpopro (0, fmt,
				((DWORD) psubseg->rpara) * 16L,
				psubseg->newreg,
				psubseg->newreg,
				((DWORD) psubseg->rpara) * 16L);
		} /* Owner is HARPO */
	} /* End for () */

	/* Write COMMAND.COM (C=) and environment (E=) to profile */
	if (HarpoComspec) {

		// C=%ld,%d    ; Move COMMAND.COM to region %d for %ld bytes
		sprintf (fmt, "C=%%5lu,%%d%s", MsgComspec);
		add2harpopro (0, fmt,
				((DWORD) HarpoComspec->ipara) * 16L,
				HarpoComspec->preg,
				HarpoComspec->preg,
				((DWORD) HarpoComspec->ipara) * 16L);

		// Note that epar0 != 0 and ereg=0 means the environment
		// goes in the same region as the program.  If the environment
		// goes low, epar0 == 0.
		if (HarpoComspec->epar0) {
			int envreg;

			if (HarpoComspec->ereg) envreg=HarpoComspec->ereg;
			else			envreg=HarpoComspec->preg;

			sprintf (fmt, "E=%%5lu,%%d%s", MsgEnvironment);
			// Note that the MAC para is included in EPAR0
			// and EPAR1, but we need to save the size value
			// the same as we do for the other subsegs- without
			// the MAC para and consistent with util MAPMEM.
			add2harpopro (0, fmt,
				((DWORD) HarpoComspec->epar0 - 1) * 16L,
				envreg,
				envreg,
				((DWORD) HarpoComspec->epar0 - 1) * 16L);
		} // Environment loaded high

	} // COMMAND.COM is present

	/* Write implicit SHARE= to profile */

	/* Save changed HARPO profile */
	close_harpopro (1);

 } /* Open was successful */

} /* End wrharpo () */

#endif			/* ifdef HARPO */

